#include <errno.h>
#include <string.h>
#include <stdio.h>

#include "error.h"

char * errors[] = {
/* ~ error */
	"no", "unknown", 
	"file open", "file close",
	"read",	"write",
	"seek", "truncate",
	"out of buffer space",
	"create directory", "open directory", "change directory",
	"stat",
	"invalid option",
	"internal program"
};

struct g_error_t g_error;

void qerror(int errortype, char const * desc)
{
	g_error.is_set=1;
	g_error.type=errortype;
	g_error.desc[sizeof(g_error.desc)-1]=0;
	g_error.msg[sizeof(g_error.desc)-1]=0;
	strncpy(g_error.desc,desc,sizeof(g_error.desc)-1);
	strncpy(g_error.msg,strerror(errno),sizeof(g_error.desc)-1);
};

void qerror2(int errortype, char const * desc, char const * desc2)
{
	g_error.is_set=1;
	g_error.type=errortype;
	g_error.desc[sizeof(g_error.desc)-1]=0;
	g_error.msg[sizeof(g_error.desc)-1]=0;
	strncpy(g_error.desc,desc,sizeof(g_error.desc)-1);
	strncat(g_error.desc,desc2,sizeof(g_error.desc)-strlen(g_error.desc)-1);
	strncpy(g_error.msg,strerror(errno),sizeof(g_error.desc)-1);
};

void qerror_m(int errortype, char const * desc, char const * msg)
{
	g_error.is_set=1;
	g_error.type=errortype;
	g_error.desc[sizeof(g_error.desc)-1]=0;
	g_error.msg[sizeof(g_error.desc)-1]=0;
	strncpy(g_error.desc,desc,sizeof(g_error.desc)-1);
	strncpy(g_error.msg,msg,sizeof(g_error.desc)-1);
};

void qerror_c(void)
{
	g_error.is_set=0;
	g_error.desc[0]=0;
	g_error.msg[0]=0;
};

void qerror_i(char const * desc)
{
	char tmp[sizeof(g_error.desc)];
	if(!g_error.is_set) {
		qerror_m(EEINTERNAL, "(n/a)", "error exit requested, but no error was reported");
	}
	strncpy(tmp,g_error.desc,sizeof(g_error.desc)-1);
	strncpy(g_error.desc,desc,sizeof(g_error.desc)-1);
	strncat(g_error.desc,tmp,sizeof(g_error.desc)-strlen(g_error.desc)-1);
	g_error.desc[sizeof(g_error.desc)-1]=0;
};

void xerror()
{
	if(!g_error.is_set) {
		qerror_m(EEUNKNOWN, "(n/a)", "error exit requested, but no error was reported");
    }
	fprintf(stderr,"%s error %s: %s\n", errors[g_error.type], g_error.desc, g_error.msg);
};
